#!/bin/bash
#set -x
CPU_INFO="/etc/cpuinfo"

function set_boot () 
{
   if ( dd if=/dev/hda bs=512 count=1  2>/dev/null |grep GRUB >/dev/null 2>&1 ) ; then 
      BOOTLOADER="grub" 
   else
      BOOTLOADER="lilo" 
   fi
   BOOT_DISK="$(mount |grep boot|cut -b 1-8)"
   [ "$BOOT_DISK" = "" ] && BOOT_DISK="/dev/hda"
   if [ "$BOOTLOADER" = "grub" ] ; then
      grub-install $BOOT_DISK
   else
      lilo
   fi   
}

function set_lpj ()
{
   sed -i /etc/lilo.conf -e "s/^append\(.*\)[ ]*lpj=[0-9]*[ ]*\(.*\)/append\1 \2/"
   sed -i /boot/grub/grub.conf -e "s/^kernel \(.*\)[ ]*lpj=[0-9]*[ ]*\(.*\)/kernel \1 \2/"
   if [ "$1" = "set" ] ; then
      LPJ="$(dmesg|grep -m 1 "(lpj=[0-9]*" |sed -e "s/.*(lpj=\([0-9]*\).*/\1/")"
      logger -s "LPJ wird auf $LPJ gesetzt"
      sed -i /etc/lilo.conf -e "s/[ ]*$//g" -e "s/[ ]*\"$/\"/g" -e "s/^append\(.*\".*\)[ ]*\"/append\1 lpj=$LPJ\"/"
      sed -i /boot/grub/grub.conf -e "s/[ ]*$//g" -e "s/^kernel \(.*\)[ ]*$/kernel \1 lpj=$LPJ/"
   fi      
   set_boot
}


MAKE_FLAGS="mmx mmx2 mmxext sse sse2 3dnow 3dnowext"
CPU_FLAGS=$(grep "^flags" /proc/cpuinfo)

#remove LPJ
sed -i /etc/lilo.conf -e "s/\(.*\)lpj=[0-9]*\(.*\)/\1\2/"

MAKECONF="/etc/make.conf"
source $MAKECONF

for i in $MAKE_FLAGS ; do
   if ( strstr " $USE " " $i " ) && ( ! strstr " $CPU_FLAGS " " $i " ); then
      logger -s "USE flag $i ist gesetzt, aber die CPU kanns nicht !!!"
   elif ( ! strstr " $USE " " $i " ) && ( strstr " $CPU_FLAGS " " $i " ); then  
      logger -s "USE flag $i ist nicht gesetzt, aber die CPU kanns !!!"
   fi
done

set_lpj set

sh /_config/bin/powernow.sh
