#!/bin/sh
source /etc/vdr.d/conf/gen2vdr.cfg
source /etc/vdr.d/conf/vdr
#set -x

NICE_VAL=${NOAD_NICE:-10}
#set -x
function execute() {
   log "Starte <$@>"
   nice -n $NICE_VAL "$@" 2>&1 | tee -a $LOG
   rc=${PIPESTATUS[0]}
   log "Exit <rc:$rc><$@>"
}

function log() {
   logger -s "$*"
   echo "$(date +"%D %T") - $*" >> $LOG   
} 

if [ "$(pidof -o %PPID -x $0)" != "" ] ; then
   logger -s "$0 is already running"
   exit
fi
      
LOG="/log/maintain_recs.log"

[ "${VIDEO: -1}" != "/" ] && VIDEO="${VIDEO}/"

if [ "$USE_CUTTING_DIR" = "1" ] ; then
   TARGET_DIR="${VIDEO}_CUT_/"
   [ ! -e $TARGET_DIR ] && mkdir $TARGET_DIR
else   
   TARGET_DIR="${VIDEO}"
fi   

TFS=$(df $TARGET_DIR |tail -n 1| cut -f 1 -d " ")
SFS=$(df $VIDEO |tail -n 1| cut -f 1 -d " ")

# Delete empty directories
find $VIDEO -follow -type d -name "*" 2>/dev/null | while read i; do
   rmdir -p --ignore-fail-on-non-empty $i 2>/dev/null
done

# Start noad or cutting for all recordings
find $VIDEO -follow -type d -name "*.rec" 2>/dev/null | while read i; do
   touch ${VIDEO}.update
   VID_FN=${i%.rec*}
   VID_RECDATE=${VID_FN##*/}
   VID_FN=${VID_FN%/*}
   VID_BASE="${VID_FN%/*}/"
   VID_FN=${VID_FN##*/}
   if [ "${VID_FN:0:1}" = "%" -o -d "${VID_BASE}%$VID_FN" ] ; then
      echo "Ignoring $i (already cutted)"
   elif [ "$MAINTAIN_NOAD" = "1" ] && [ ! -f "$i/marks.vdr" ] ; then
      execute /_config/bin/g2v_noad.sh - "$i"
      touch "$i/marks.vdr"
      cp -a "$i/marks.vdr" "$i/marks_noad.vdr"
   elif [ "$MAINTAIN_CUTTING" = "1" ] && [ -s "$i/marks.vdr" ] ; then
      TARGET="${TARGET_DIR}${VID_BASE#$VIDEO}%${VID_FN}/${VID_RECDATE}.rec"
      if [ ! -f "$i/marks_noad.vdr" -o "$i/marks.vdr" -nt "$i/marks_noad.vdr" ] ; then
         # Check Disk free
         if [ "$TFS" != "$SFS" ] ; then
            ds=$(du -s -B 1000 "$i" |tr "\t" " "| cut -f 1 -d " ")
            tf=$(df -B 1000 $TARGET_DIR |tail -n 1|tr "\t" " "| tr -s " " | cut -f 4 -d " ")
            if [ $ds -ge $tf ] ; then
               log "Not cutting $i <$ds kB needed-$tf kB free>"
               continue
            fi
         fi
         log "Cutting $i to <$TARGET>"
         execute hlcut -w -v -r "$i" -o "$TARGET"
         cp -a "$i/marks.vdr" "$i/marks_noad.vdr"
      fi
   fi
done
touch ${VIDEO}.update
