#!/bin/sh
set -x
source /etc/vdr.d/conf/vdr
export DISPLAY=:0.0			
export LANG=de_DE			  

# Set this if you are using a remote server or another protocol
XINE_SERVER="xvdr://localhost"
source /etc/vdr.d/conf/vdr

logger "$0 starting ..."
LOG="/log/oxine.log"

CARDS=$(cat /proc/asound/cards | awk '/: / { print $1 }')
if [ "$CARDS" != "" ] ; then
   AO="alsa"
else
   AO="none"   
fi   
if [ "$(xvinfo | grep "no adaptors present")" = "" ] ; then
   VO="xv"
else
   VO="xshm"      
fi

OVL=0
case "$PLUGINS" in
   *em84xx*)
      OVL=1
      cp /root/.oxine/mainmenu.xml.vdr /root/.oxine/mainmenu.xml
      ;;
   *xine*)      
      cp /root/.oxine/mainmenu.xml.xine /root/.oxine/mainmenu.xml
      ;;
esac
						      
killall -9 oxine > /dev/null 2>&1

if [ "$GUI" = "VDR_oxine" ] && [ "$OVL" = "0" ] ; then
   url="$XINE_SERVER#nocache;demux:mpeg_block"
else
   url=""
fi
      
while [ ! -e /tmp/.shutdown ] ; do
   oxine --verbose=2 -n $url -V $VO -A $AO -l $LOG > /log/oxine.out 2>&1
done
logger "$0 - exiting"   
