#!/bin/bash
#
source /etc/vdr.d/conf/gen2vdr.cfg
source /etc/vdr.d/conf/vdr

rc-update del freevo > /dev/null 2>&1
rc-update del oxine > /dev/null 2>&1
rc-update del xvdr > /dev/null 2>&1
rc-update del gui > /dev/null 2>&1

FRV_SKINS=$(ls /usr/share/freevo/skins/main/*.fxd | sed -e "s:.*/::" -e "s:\.fxd::")
ADMIN_FSK=$(grep ":FREEVO_SKIN:" /etc/vdr/plugins/admin/admin.conf)
CHANGED=0
#set -x
for i in $FRV_SKINS ; do
   if [ "$(echo "$ADMIN_FSK" | grep "[:,]$i[:,]")" = "" ] ; then
      ADMIN_FSK="$(echo $ADMIN_FSK | sed -e "s/:FreeVo/,$i:FreeVo/")"
      CHANGED=1
   fi
done
if [ "$CHANGED" = "1" ] ; then
   sed -i /etc/vdr/plugins/admin/admin.conf -e "s%.*:FREEVO_SKIN:.*%$ADMIN_FSK%"
   $SETVAL FREEVO_SKIN "$FREEVO_SKIN"
fi

[ "$1" = "-check" ] && exit
			
logger -s "ADMIN - GUI: $GUI"

BOARD="$(/_config/bin/query_mb.sh)"

if [ "$GUI" = "FreeVo" -o "$GUI" = "VDR_FreeVo" ] ; then
   sed -i /etc/vdr.d/plugins/swcon -e "s/-t .*/-t FreeVo\"/"
   rc-update add freevo boot
elif [ "$GUI" = "oxine" -o "$GUI" = "VDR_oxine" ] ; then
   sed -i /etc/vdr.d/plugins/swcon -e "s/-t .*/-t oxine\"/"
   rc-update add oxine boot
#   logger -s "Untersuche Audio und Videoverzeichnis - kann lange dauern !"
#   freevo cache
elif [ "$GUI" = "XFCE" ] ; then
   sed -i /etc/rc.conf -e "s/^XSESSION=.*/XSESSION=\"Xfce4\"/"
   rc-update add gui default
elif [ "$GUI" = "KDE" ] ; then
   sed -i /etc/rc.conf -e "s/^XSESSION=.*/XSESSION=\"kde-3.5\"/"
   rc-update add gui default
elif [ "$GUI" = "VDR" ] ; then
   rc-update add xvdr boot
else
   echo "Unknown GUI parameter $1"
   exit 1
fi

sh /_config/bin/set_xorgres.sh   

depscan.sh
exit 0
